(function e(t,n,r){function s(o,u){if(!n[o]){if(!t[o]){var a=typeof require=="function"&&require;if(!u&&a)return a(o,!0);if(i)return i(o,!0);throw new Error("Cannot find module '"+o+"'")}var f=n[o]={exports:{}};t[o][0].call(f.exports,function(e){var n=t[o][1][e];return s(n?n:e)},f,f.exports,e,t,n,r)}return n[o].exports}var i=typeof require=="function"&&require;for(var o=0;o<r.length;o++)s(r[o]);return s})({1:[function(require,module,exports){
'use strict';

/**
 * Representation of a single EventEmitter function.
 *
 * @param {Function} fn Event handler to be called.
 * @param {Mixed} context Context for function execution.
 * @param {Boolean} once Only emit once
 * @api private
 */
function EE(fn, context, once) {
  this.fn = fn;
  this.context = context;
  this.once = once || false;
}

/**
 * Minimal EventEmitter interface that is molded against the Node.js
 * EventEmitter interface.
 *
 * @constructor
 * @api public
 */
function EventEmitter() { /* Nothing to set */ }

/**
 * Holds the assigned EventEmitters by name.
 *
 * @type {Object}
 * @private
 */
EventEmitter.prototype._events = undefined;

/**
 * Return a list of assigned event listeners.
 *
 * @param {String} event The events that should be listed.
 * @returns {Array}
 * @api public
 */
EventEmitter.prototype.listeners = function listeners(event) {
  if (!this._events || !this._events[event]) return [];
  if (this._events[event].fn) return [this._events[event].fn];

  for (var i = 0, l = this._events[event].length, ee = new Array(l); i < l; i++) {
    ee[i] = this._events[event][i].fn;
  }

  return ee;
};

/**
 * Emit an event to all registered event listeners.
 *
 * @param {String} event The name of the event.
 * @returns {Boolean} Indication if we've emitted an event.
 * @api public
 */
EventEmitter.prototype.emit = function emit(event, a1, a2, a3, a4, a5) {
  if (!this._events || !this._events[event]) return false;

  var listeners = this._events[event]
    , len = arguments.length
    , args
    , i;

  if ('function' === typeof listeners.fn) {
    if (listeners.once) this.removeListener(event, listeners.fn, true);

    switch (len) {
      case 1: return listeners.fn.call(listeners.context), true;
      case 2: return listeners.fn.call(listeners.context, a1), true;
      case 3: return listeners.fn.call(listeners.context, a1, a2), true;
      case 4: return listeners.fn.call(listeners.context, a1, a2, a3), true;
      case 5: return listeners.fn.call(listeners.context, a1, a2, a3, a4), true;
      case 6: return listeners.fn.call(listeners.context, a1, a2, a3, a4, a5), true;
    }

    for (i = 1, args = new Array(len -1); i < len; i++) {
      args[i - 1] = arguments[i];
    }

    listeners.fn.apply(listeners.context, args);
  } else {
    var length = listeners.length
      , j;

    for (i = 0; i < length; i++) {
      if (listeners[i].once) this.removeListener(event, listeners[i].fn, true);

      switch (len) {
        case 1: listeners[i].fn.call(listeners[i].context); break;
        case 2: listeners[i].fn.call(listeners[i].context, a1); break;
        case 3: listeners[i].fn.call(listeners[i].context, a1, a2); break;
        default:
          if (!args) for (j = 1, args = new Array(len -1); j < len; j++) {
            args[j - 1] = arguments[j];
          }

          listeners[i].fn.apply(listeners[i].context, args);
      }
    }
  }

  return true;
};

/**
 * Register a new EventListener for the given event.
 *
 * @param {String} event Name of the event.
 * @param {Functon} fn Callback function.
 * @param {Mixed} context The context of the function.
 * @api public
 */
EventEmitter.prototype.on = function on(event, fn, context) {
  var listener = new EE(fn, context || this);

  if (!this._events) this._events = {};
  if (!this._events[event]) this._events[event] = listener;
  else {
    if (!this._events[event].fn) this._events[event].push(listener);
    else this._events[event] = [
      this._events[event], listener
    ];
  }

  return this;
};

/**
 * Add an EventListener that's only called once.
 *
 * @param {String} event Name of the event.
 * @param {Function} fn Callback function.
 * @param {Mixed} context The context of the function.
 * @api public
 */
EventEmitter.prototype.once = function once(event, fn, context) {
  var listener = new EE(fn, context || this, true);

  if (!this._events) this._events = {};
  if (!this._events[event]) this._events[event] = listener;
  else {
    if (!this._events[event].fn) this._events[event].push(listener);
    else this._events[event] = [
      this._events[event], listener
    ];
  }

  return this;
};

/**
 * Remove event listeners.
 *
 * @param {String} event The event we want to remove.
 * @param {Function} fn The listener that we need to find.
 * @param {Boolean} once Only remove once listeners.
 * @api public
 */
EventEmitter.prototype.removeListener = function removeListener(event, fn, once) {
  if (!this._events || !this._events[event]) return this;

  var listeners = this._events[event]
    , events = [];

  if (fn) {
    if (listeners.fn && (listeners.fn !== fn || (once && !listeners.once))) {
      events.push(listeners);
    }
    if (!listeners.fn) for (var i = 0, length = listeners.length; i < length; i++) {
      if (listeners[i].fn !== fn || (once && !listeners[i].once)) {
        events.push(listeners[i]);
      }
    }
  }

  //
  // Reset the array, or remove it completely if we have no more listeners.
  //
  if (events.length) {
    this._events[event] = events.length === 1 ? events[0] : events;
  } else {
    delete this._events[event];
  }

  return this;
};

/**
 * Remove all listeners or only the listeners for the specified event.
 *
 * @param {String} event The event want to remove all listeners for.
 * @api public
 */
EventEmitter.prototype.removeAllListeners = function removeAllListeners(event) {
  if (!this._events) return this;

  if (event) delete this._events[event];
  else this._events = {};

  return this;
};

//
// Alias methods names because people roll like that.
//
EventEmitter.prototype.off = EventEmitter.prototype.removeListener;
EventEmitter.prototype.addListener = EventEmitter.prototype.on;

//
// This function doesn't apply anymore.
//
EventEmitter.prototype.setMaxListeners = function setMaxListeners() {
  return this;
};

//
// Expose the module.
//
EventEmitter.EventEmitter = EventEmitter;
EventEmitter.EventEmitter2 = EventEmitter;
EventEmitter.EventEmitter3 = EventEmitter;

//
// Expose the module.
//
module.exports = EventEmitter;

},{}],2:[function(require,module,exports){
var ComboTextInput, DialInput, FunctionProperty, MonoInputRow, NumberInput, NumberProperty, OptionListProperty, PairedInputRow, Panel, PanelRow, RadioSelectInput, SelectInput, SliderInput, StereoInputRow, TextInput,
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

NumberProperty = FramerComponents.NumberProperty, FunctionProperty = FramerComponents.FunctionProperty, OptionListProperty = FramerComponents.OptionListProperty;

Panel = FramerComponents.Panel, PanelRow = FramerComponents.PanelRow, MonoInputRow = FramerComponents.MonoInputRow, StereoInputRow = FramerComponents.StereoInputRow, PairedInputRow = FramerComponents.PairedInputRow;

TextInput = FramerComponents.TextInput, ComboTextInput = FramerComponents.ComboTextInput, NumberInput = FramerComponents.NumberInput, SliderInput = FramerComponents.SliderInput, DialInput = FramerComponents.DialInput, SelectInput = FramerComponents.SelectInput, RadioSelectInput = FramerComponents.RadioSelectInput;

exports.AnimationOptionsPanel = (function(superClass) {
  extend(AnimationOptionsPanel, superClass);

  function AnimationOptionsPanel(options) {
    if (options == null) {
      options = {};
    }
    this.caption = "Animation Options";
    AnimationOptionsPanel.__super__.constructor.call(this, _.defaults(options, {}));
    this.delayRow = new PairedInputRow({
      caption: "Delay",
      editorTypes: [NumberInput, SliderInput],
      property: new NumberProperty({
        dataPath: "delay",
        caption: "S",
        min: 0,
        sliderMax: 5
      })
    });
    this.repeatRow = new PairedInputRow({
      caption: "Repeat",
      editorTypes: [NumberInput, SliderInput],
      property: new NumberProperty({
        dataPath: "repeat",
        min: 0,
        sliderMax: 10
      })
    });
    this.colorModel = new MonoInputRow({
      caption: "Color",
      rightEditorInsetY: 2,
      properties: new OptionListProperty({
        editorType: RadioSelectInput,
        dataPath: "colorModel",
        availableOptions: {
          "rgb": "RGB",
          "hsl": "HSL",
          "husl": "HUSL"
        }
      })
    });
    this.add(this.delayRow);
    this.add(this.repeatRow);
    this.add(this.colorModel);
  }

  return AnimationOptionsPanel;

})(Panel);



},{}],3:[function(require,module,exports){
var AnimationOptionsPanel, AutoCodePanelStack, CurvePanel, NumberProperty, StringProperty,
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

AutoCodePanelStack = require('../shared/AutoCodePanelStack').AutoCodePanelStack;

CurvePanel = require('./CurvePanel').CurvePanel;

AnimationOptionsPanel = require('./AnimationOptionsPanel').AnimationOptionsPanel;

StringProperty = FramerComponents.StringProperty, NumberProperty = FramerComponents.NumberProperty;

exports.AnimationPanelStack = (function(superClass) {
  extend(AnimationPanelStack, superClass);

  function AnimationPanelStack(options) {
    if (options == null) {
      options = {};
    }
    this.currentTabName = 'options';
    AnimationPanelStack.__super__.constructor.call(this, options);
    this.directManipulationProperties = {
      curve: {
        "default": "ease"
      },
      time: {
        "default": 1,
        round: true
      },
      delay: {
        "default": 0,
        round: true
      },
      repeat: {
        "default": 0,
        round: true
      },
      colorModel: {
        "default": "husl"
      }
    };
    this.curvePanel = new CurvePanel;
    this.optionsPanel = new AnimationOptionsPanel;
    this.add(this.curvePanel);
    this.add(this.optionsPanel);
  }

  AnimationPanelStack.prototype.setData = function(data) {
    AnimationPanelStack.__super__.setData.call(this, data);
    return this.render();
  };

  return AnimationPanelStack;

})(AutoCodePanelStack);



},{"../shared/AutoCodePanelStack":6,"./AnimationOptionsPanel":2,"./CurvePanel":4}],4:[function(require,module,exports){
var BezierCurveAnimator, Curve, FunctionProperty, LinearAnimator, MonoInputRow, NumberInput, NumberProperty, OptionListProperty, PairedInputRow, Panel, RadioSelectInput, SliderInput, SpringRK4Animator, StringProperty, WidgetRow,
  bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

OptionListProperty = FramerComponents.OptionListProperty, StringProperty = FramerComponents.StringProperty, FunctionProperty = FramerComponents.FunctionProperty, NumberProperty = FramerComponents.NumberProperty;

Panel = FramerComponents.Panel, MonoInputRow = FramerComponents.MonoInputRow, WidgetRow = FramerComponents.WidgetRow, PairedInputRow = FramerComponents.PairedInputRow;

NumberInput = FramerComponents.NumberInput, SliderInput = FramerComponents.SliderInput, RadioSelectInput = FramerComponents.RadioSelectInput;

Curve = FramerComponents.Curve;

LinearAnimator = Framer.LinearAnimator, BezierCurveAnimator = Framer.BezierCurveAnimator, SpringRK4Animator = Framer.SpringRK4Animator;

exports.CurvePanel = (function(superClass) {
  extend(CurvePanel, superClass);

  function CurvePanel(options) {
    var defaultAnimator, toleranceProperty;
    if (options == null) {
      options = {};
    }
    this.curveSelectionChanged = bind(this.curveSelectionChanged, this);
    this.springChanged = bind(this.springChanged, this);
    this.highlightEaseOption = bind(this.highlightEaseOption, this);
    this.highlightSpringOption = bind(this.highlightSpringOption, this);
    CurvePanel.__super__.constructor.call(this, options);
    this.caption = "Curve";
    this.curveProperty = new StringProperty({
      dataPath: "curve"
    });
    this.curveSelectionProperty = new OptionListProperty({
      editorType: RadioSelectInput,
      availableOptions: {
        "ease": "Ease",
        "ease-in": "Ease In",
        "ease-out": "Ease Out",
        "ease-in-out": "Ease In Out",
        "spring": "Spring"
      }
    });
    this.curveRow = new MonoInputRow({
      caption: "Curve",
      editorType: RadioSelectInput,
      properties: this.curveSelectionProperty
    });
    this.widgetRow = new WidgetRow({
      widgetType: Curve,
      caption: " "
    });
    this.add(this.curveRow);
    this.add(this.widgetRow);
    this.timeProperty = new NumberProperty({
      dataPath: "time",
      caption: "S",
      min: 0,
      sliderMax: 5,
      decimals: 2,
      step: 0.25
    });
    this.springProperty = new FunctionProperty({
      name: "spring"
    });
    this.tensionProperty = new NumberProperty({
      min: 0,
      max: 1000,
      sliderMin: 100,
      sliderTransform: function(x) {
        return Math.pow(10, x);
      },
      sliderInverseTransform: function(x) {
        return Math.log10(x);
      },
      decimals: 0,
      caption: " "
    });
    this.frictionProperty = new NumberProperty({
      min: 0,
      max: 100,
      sliderMin: 10,
      sliderTransform: function(x) {
        return Math.pow(10, x);
      },
      sliderInverseTransform: function(x) {
        return Math.log10(x);
      },
      decimals: 0,
      caption: " "
    });
    this.velocityProperty = new NumberProperty({
      min: 0,
      max: 25,
      step: 1,
      decimals: 0,
      caption: " "
    });
    toleranceProperty = new NumberProperty;
    defaultAnimator = new SpringRK4Animator;
    this.tensionProperty["default"] = defaultAnimator.options.tension;
    this.frictionProperty["default"] = defaultAnimator.options.friction;
    this.velocityProperty["default"] = defaultAnimator.options.velocity;
    this.springProperty.addArgument(this.tensionProperty);
    this.springProperty.addArgument(this.frictionProperty);
    this.springProperty.addArgument(this.velocityProperty);
    this.springProperty.addArgument(toleranceProperty);
    this.timeRow = new PairedInputRow({
      caption: "Time",
      editorTypes: [NumberInput, SliderInput],
      property: this.timeProperty
    });
    this.tension = new PairedInputRow({
      caption: "Tension",
      editorTypes: [NumberInput, SliderInput],
      rightEditorInsetY: 2,
      property: this.tensionProperty
    });
    this.friction = new PairedInputRow({
      caption: "Friction",
      editorTypes: [NumberInput, SliderInput],
      rightEditorInsetY: 2,
      property: this.frictionProperty
    });
    this.velocity = new PairedInputRow({
      caption: "Velocity",
      editorTypes: [NumberInput, SliderInput],
      rightEditorInsetY: 2,
      property: this.velocityProperty
    });
    this.timeRow.on("click:disabledLayer", this.highlightEaseOption);
    this.tension.on("click:disabledLayer", this.highlightSpringOption);
    this.friction.on("click:disabledLayer", this.highlightSpringOption);
    this.velocity.on("click:disabledLayer", this.highlightSpringOption);
    this.add(this.timeRow);
    this.add(this.tension);
    this.add(this.friction);
    this.add(this.velocity);
    this.properties = [this.curveProperty, this.timeProperty];
    this.curveChangesEnabled = true;
    this.curveSelectionProperty.on("change:value", this.curveSelectionChanged);
    this.curveSelectionProperty.on("request", (function(_this) {
      return function(request) {
        request.name = _this.curveProperty.dataPath;
        return _this.curveProperty.emit("request", request);
      };
    })(this));
    this.springProperty.on("request", (function(_this) {
      return function(request) {
        request.name = _this.curveProperty.dataPath;
        return _this.curveProperty.emit("request", request);
      };
    })(this));
    this.tensionProperty.on("change:value", this.springChanged);
    this.frictionProperty.on("change:value", this.springChanged);
    this.velocityProperty.on("change:value", this.springChanged);
    this.curveProperty.on("change:value", (function(_this) {
      return function(value) {
        _this.curveChangesEnabled = false;
        _this.curveSelectionProperty.settings = _this.curveProperty.settings;
        _this.springProperty.settings = _this.curveProperty.settings;
        if (_.startsWith(value, "spring")) {
          _this.curveSelectionProperty.value = "spring";
          _this.springProperty.setValueWithData(value);
        } else {
          if (!_this.curveSelectionProperty.validateOption(value)) {
            value = "";
          }
          _this.curveSelectionProperty.value = value;
        }
        return _this.curveChangesEnabled = true;
      };
    })(this));
    this.curveProperty.on("reset", (function(_this) {
      return function() {
        _this.curveSelectionProperty.reset();
        return _this.springProperty.reset();
      };
    })(this));
    this.curveProperty.on("change:default", (function(_this) {
      return function(defaultValue) {
        _this.curveChangesEnabled = false;
        _this.curveSelectionProperty["default"] = defaultValue;
        _this.curveChangesEnabled = true;
        if (defaultValue != null) {
          return _this.updateWidget();
        }
      };
    })(this));
  }

  CurvePanel.prototype.highlightSpringOption = function() {
    return this.curveRow.editor.highlight("spring");
  };

  CurvePanel.prototype.highlightEaseOption = function() {
    return this.curveRow.editor.highlight("ease");
  };

  CurvePanel.prototype.springChanged = function() {
    this.updateCurveProperty(this.springProperty.valueAsString());
    return this.updateWidget();
  };

  CurvePanel.prototype.updateCurveProperty = function(value) {
    if (!this.curveChangesEnabled) {
      return;
    }
    return this.curveProperty.value = value;
  };

  CurvePanel.prototype.curveSelectionChanged = function(value) {
    if (value === "spring") {
      this.widgetRow.widget.factor = 0.5;
      this.timeRow.disable();
      this.tension.enable();
      this.friction.enable();
      this.velocity.enable();
      return this.springChanged();
    } else {
      this.widgetRow.widget.factor = 1;
      this.timeRow.enable();
      this.tension.disable();
      this.friction.disable();
      this.velocity.disable();
      this.updateCurveProperty(value);
      return this.updateWidget();
    }
  };

  CurvePanel.prototype.updateWidget = function() {
    var animator, curve, options, ref, ref1, time;
    options = {};
    time = (ref = this.timeProperty.value) != null ? ref : this.timeProperty["default"];
    curve = (ref1 = this.curveProperty.value) != null ? ref1 : this.curveProperty["default"];
    if (time != null) {
      options.time = time;
    }
    if (curve != null) {
      options.curve = curve;
    }
    animator = Utils.animatorFor(options);
    if (this.curveProperty.settings.disabled) {
      animator = null;
    }
    if (animator != null) {
      animator.options.tolerance = 1 / 10000;
    }
    return this.widgetRow.widget.render(animator);
  };

  return CurvePanel;

})(Panel);



},{}],5:[function(require,module,exports){
var AnimationPanelStack, Constants, Scroller, animation, bridge, scroller;

bridge = (require("./../shared/Bridge")).bridge;

Constants = require("./../shared/Constants").Constants;

Scroller = require("./../shared/Scroller").Scroller;

AnimationPanelStack = require("./AnimationPanelStack").AnimationPanelStack;

scroller = new Scroller({
  backgroundColor: Constants.colors.background
});

animation = new AnimationPanelStack({
  parent: scroller,
  backgroundColor: Constants.colors.background
});

bridge.responders.setData = animation.setData;

bridge.responders.getToggleStates = animation.getToggleStates;

Framer.Extras.TouchEmulator.disable();

Framer.Extras.ErrorDisplay.disable();



},{"./../shared/Bridge":7,"./../shared/Constants":8,"./../shared/Scroller":9,"./AnimationPanelStack":3}],6:[function(require,module,exports){
var Constants, SwitchPanel, bridge,
  bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

bridge = require("./Bridge").bridge;

Constants = require("./Constants").Constants;

SwitchPanel = require('../shared/SwitchPanel').SwitchPanel;

exports.AutoCodePanelStack = (function(superClass) {
  extend(AutoCodePanelStack, superClass);

  function AutoCodePanelStack(options) {
    if (options == null) {
      options = {};
    }
    this.handleUndoValue = bind(this.handleUndoValue, this);
    this.handleExternalValueUpdate = bind(this.handleExternalValueUpdate, this);
    this.handlePropertyRequest = bind(this.handlePropertyRequest, this);
    this.handlePropertyValueChange = bind(this.handlePropertyValueChange, this);
    this.handleLayerEdited = bind(this.handleLayerEdited, this);
    this.handleTabChange = bind(this.handleTabChange, this);
    this.setData = bind(this.setData, this);
    AutoCodePanelStack.__super__.constructor.call(this, _.defaults(options, {}));
    bridge.on("show", (function(_this) {
      return function() {
        return _this.visible = true;
      };
    })(this));
    bridge.on("hide", (function(_this) {
      return function() {
        return _this.visible = false;
      };
    })(this));
    bridge.on(Constants.messages.framerview.layerEdited, this.handleLayerEdited);
    bridge.on("externalValueUpdate", this.handleExternalValueUpdate);
    bridge.on("undoValue", this.handleUndoValue);
    this.directManipulationProperties = {};
    this.omitDefaults = true;
    this.visible = false;
    this.switchPanel = new SwitchPanel({
      currentTabName: this.currentTabName
    });
    this.switchPanel.tabs.on("change:value", this.handleTabChange);
    this.add(this.switchPanel);
  }

  AutoCodePanelStack.prototype.destroy = function() {
    return this.reset();
  };

  AutoCodePanelStack.prototype.configure = function(data) {};

  AutoCodePanelStack.prototype.setData = function(data) {
    var i, key, len, member, ref, ref1, ref2, settings, value;
    this.reset();
    this.configure(data);
    this.pathPrefix = data.pathPrefix;
    this.switchPanel.visible = (ref = data.switchAvailable) != null ? ref : false;
    this.initialValues = data != null ? data.layerProperties : void 0;
    if (this.initialValues == null) {
      this.initialValues = {};
    }
    ref1 = this.directManipulationProperties;
    for (key in ref1) {
      value = ref1[key];
      if (this.initialValues[key] == null) {
        this.initialValues[key] = value["default"];
      }
      value.initial = this.initialValues[key];
      value.changed = false;
    }
    settings = {};
    ref2 = data.frozenMembers;
    for (i = 0, len = ref2.length; i < len; i++) {
      member = ref2[i];
      Utils.setValueForKeyPath(settings, member, {
        disabled: true
      });
    }
    this.setMembers = data.setMembers;
    if ((this.pathPrefix != null) && this.pathPrefix.length > 0) {
      this.setMembers = this.setMembers[this.pathPrefix];
      settings = settings[this.pathPrefix];
    }
    this.read(this.setMembers, this.initialValues, settings);
    this.addPropertyListeners();
    return window.scrollTo(0, 0);
  };

  AutoCodePanelStack.prototype.getData = function() {
    return this.write();
  };

  AutoCodePanelStack.prototype.addPropertyListeners = function() {
    var i, len, property, ref, results;
    ref = this.properties;
    results = [];
    for (i = 0, len = ref.length; i < len; i++) {
      property = ref[i];
      results.push(property.on("change:value", this.handlePropertyValueChange));
    }
    return results;
  };

  AutoCodePanelStack.prototype.removePropertyListeners = function() {
    var i, len, property, ref, results;
    ref = this.properties;
    results = [];
    for (i = 0, len = ref.length; i < len; i++) {
      property = ref[i];
      property.off("change:value", this.handlePropertyValueChange);
      results.push(property.reset());
    }
    return results;
  };

  AutoCodePanelStack.prototype.reset = function() {
    return this.removePropertyListeners();
  };

  AutoCodePanelStack.prototype.propertyByDataPath = function(dataPath) {
    var i, len, property, ref;
    ref = this.properties;
    for (i = 0, len = ref.length; i < len; i++) {
      property = ref[i];
      if (property.dataPath === dataPath) {
        return property;
      }
    }
    return null;
  };

  AutoCodePanelStack.prototype.handleTabChange = function(value) {
    if (value === this.currentTabName) {
      return;
    }
    return bridge.send(Constants.messages.propertiespanel.activatePanel, {
      name: value
    });
  };

  AutoCodePanelStack.prototype.handleLayerEdited = function(data) {
    var changedProperties, currentValue, dataPath, newValue, property, ref, settings, value;
    this.inBatchMode = true;
    changedProperties = [];
    ref = this.directManipulationProperties;
    for (dataPath in ref) {
      settings = ref[dataPath];
      newValue = data.properties[dataPath];
      property = this.propertyByDataPath(dataPath);
      if (newValue == null) {
        continue;
      }
      if (!((property != null ? property.changed : void 0) || (this.setMembers[dataPath] != null))) {
        if ((settings.initial + "") === (newValue + "")) {
          continue;
        }
      }
      if (settings.round) {
        value = Math.round(newValue);
      } else {
        value = newValue;
      }
      if (value != null) {
        value = value + "";
      }
      if (this.omitDefaults) {
        if (value === settings["default"] + "") {
          value = null;
        }
      }
      if (value !== void 0 && (property != null)) {
        if (!this.omitDefaults && !property.changed && value === property["default"] + "") {
          value = null;
        }
        currentValue = property.getData();
        if ((value === null && currentValue !== null) || (value !== null && value.toString() !== currentValue)) {
          property.setValueWithData(value);
          property.changed = true;
          changedProperties.push({
            name: this.prefixDataPath(dataPath),
            value: value,
            type: property.type
          });
        }
      }
    }
    if (changedProperties.length > 0) {
      bridge.send(Constants.messages.propertiespanel.propertiesChanged, {
        properties: changedProperties
      });
    }
    return this.inBatchMode = false;
  };

  AutoCodePanelStack.prototype.prefixDataPath = function(dataPath) {
    if ((this.pathPrefix != null) && this.pathPrefix.length > 0) {
      return this.pathPrefix + "." + dataPath;
    } else {
      return dataPath;
    }
  };

  AutoCodePanelStack.prototype.handlePropertyValueChange = function(newValue, oldValue, prop) {
    var defaultValue, initialValue, ref, update, value;
    if (this.inBatchMode) {
      return;
    }
    value = prop.getData();
    initialValue = prop.valueToData(this.initialValues[prop.dataPath]);
    defaultValue = (ref = this.directManipulationProperties[prop.dataPath]) != null ? ref["default"] : void 0;
    if ((value == null) && initialValue !== defaultValue) {
      value = initialValue;
    }
    update = {
      name: this.prefixDataPath(prop.dataPath),
      value: value,
      type: prop.type
    };
    return bridge.send(Constants.messages.propertiespanel.propertyChanged, update);
  };

  AutoCodePanelStack.prototype.handlePropertyRequest = function(request) {
    switch (request != null ? request.type : void 0) {
      case "color":
        return bridge.send("colorPickerRequested", request);
      case "image":
        return bridge.send("imagePickerRequested", request);
      case "drag:start":
        document.body.classList.add("dragging");
        return bridge.send("drag:start", {});
      case "drag:end":
        document.body.classList.remove("dragging");
        return bridge.send("drag:end", {});
      case "click:lock":
        request.name = this.prefixDataPath(request.name);
        return bridge.send(Constants.messages.propertiespanel.propertyLockClicked, request);
    }
  };

  AutoCodePanelStack.prototype.handleExternalValueUpdate = function(update) {
    var property;
    property = this.propertyByDataPath(update != null ? update.name : void 0);
    if (property != null) {
      return property.value = update.value;
    }
  };

  AutoCodePanelStack.prototype.handleUndoValue = function(update) {
    var inBatchMode;
    inBatchMode = this.inBatchMode;
    this.inBatchMode = true;
    this.handleExternalValueUpdate(update);
    return this.inBatchMode = inBatchMode;
  };

  return AutoCodePanelStack;

})(window.FramerComponents.PanelStack);



},{"../shared/SwitchPanel":10,"./Bridge":7,"./Constants":8}],7:[function(require,module,exports){
var Bridge, EventEmitter,
  bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

EventEmitter = require("eventemitter3");

Bridge = (function(superClass) {
  extend(Bridge, superClass);

  function Bridge() {
    this.respond = bind(this.respond, this);
    this.receive = bind(this.receive, this);
    if (typeof window !== "undefined" && window !== null) {
      window._receive = this.receive;
    }
    if (typeof window !== "undefined" && window !== null) {
      window._respond = this.respond;
    }
    this.count = 0;
    this.responders = {};
  }

  Bridge.prototype.receive = function(command, info) {
    if (this.debug) {
      console.log((this.count++) + " bridge.receive", command, info);
    }
    return this.emit(command, info);
  };

  Bridge.prototype.respond = function(request, info) {
    var responder;
    responder = this.responders[request];
    if (responder != null) {
      return responder(info);
    } else {

    }
  };

  Bridge.prototype.send = function(command, info) {
    if (this.debug) {
      console.log((this.count++) + " bridge.send", command, info);
    }
    return typeof window !== "undefined" && window !== null ? typeof window._bridge === "function" ? window._bridge(command, info) : void 0 : void 0;
  };

  return Bridge;

})(EventEmitter);

exports.bridge = new Bridge();



},{"eventemitter3":1}],8:[function(require,module,exports){
exports.Constants = {
  fonts: {
    "default": {
      font: "11px -apple-system, Helvetica Neue, Helvetica",
      weight: "500"
    }
  },
  colors: {
    background: "#141414",
    text: "#888888",
    textHighlight: "#FFFFFF",
    textInvisible: "rgba(98,98,98,.4)",
    indent: "#303030",
    tableSelectionBackground: "#363636"
  },
  sizes: {
    base: 10,
    rowHeight: 28,
    indent: 12,
    indentWidth: 1,
    indentHeight: 28
  },
  messages: {
    layerpanel: {
      reset: "layerPanel:reset",
      itemRollOver: "layerPanel:itemRollover",
      itemRollOut: "layerPanel:itemRollout",
      itemClick: "layerPanel:itemClick"
    },
    propertiespanel: {
      propertiesChanged: "propertiesPanel:propertiesChanged",
      propertyChanged: "propertiesPanel:propertyChanged",
      propertyLockClicked: "propertiesPanel:propertyLockClicked",
      activatePanel: "propertiesPanel:activatePanel"
    },
    framerview: {
      layers: "framerView:layers",
      layerEdited: "framerView:layerEdited",
      layerHighlighted: "framerView:layerHighlighted"
    },
    studio: {
      state: "studio:state",
      layerPanelEnter: "studio:layerPanelEnter",
      layerPanelLeave: "studio:layerPanelLeave"
    }
  }
};



},{}],9:[function(require,module,exports){
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

exports.Scroller = (function(superClass) {
  extend(Scroller, superClass);

  function Scroller(options) {
    var ref;
    if (options == null) {
      options = {};
    }
    this.marginTop = (ref = options.y) != null ? ref : 0;
    Scroller.__super__.constructor.call(this, _.defaults(options, {
      name: "Scroller",
      y: this.marginTop,
      width: window.innerWidth,
      height: window.innerHeight - this.marginTop,
      backgroundColor: null,
      clip: true
    }));
    this.scroll = true;
    this.scrollHorizontal = false;
    window.addEventListener("resize", (function(_this) {
      return function() {
        var child, i, len, ref1, results;
        _this.height = window.innerHeight - _this.marginTop;
        _this.width = window.innerWidth;
        ref1 = _this.children;
        results = [];
        for (i = 0, len = ref1.length; i < len; i++) {
          child = ref1[i];
          results.push(typeof child.handleScrollerResize === "function" ? child.handleScrollerResize(_this.width, _this.height) : void 0);
        }
        return results;
      };
    })(this));
  }

  return Scroller;

})(Layer);



},{}],10:[function(require,module,exports){
var Panel, PanelRow, Tabs,
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty,
  bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; };

Panel = FramerComponents.Panel, PanelRow = FramerComponents.PanelRow;

Tabs = (function(superClass) {
  extend(Tabs, superClass);

  function Tabs(options) {
    var i, layer, len, ref;
    if (options == null) {
      options = {};
    }
    Tabs.__super__.constructor.call(this, _.defaults(options, {
      hasLabel: false,
      caption: "",
      height: 40
    }));
    this.left = new Layer({
      parent: this,
      backgroundColor: null,
      name: "properties"
    });
    this.propertiesIcon = new Layer({
      parent: this.left,
      width: 11,
      height: 11,
      backgroundColor: null,
      html: '<svg><defs><path d="M6.08474107,7 L2,7 L2,8 L6.08455121,8 C6.289826,8.58510886 6.84604119,9 7.5,9 C8.33420277,9 9,8.32842712 9,7.5 C9,6.66579723 8.32842712,6 7.5,6 C6.84233723,6 6.28934383,6.41740381 6.08474107,7 Z M4.91544879,3 L9,3 L9,4 L4.91525893,4 C4.71065617,4.58259619 4.15766277,5 3.5,5 C2.67157288,5 2,4.33420277 2,3.5 C2,2.67157288 2.66579723,2 3.5,2 C4.15395881,2 4.710174,2.41489114 4.91544879,3 Z M0,1.50643854 C0,0.674455507 0.671540633,0 1.50643854,0 L9.49356146,0 C10.3255445,0 11,0.671540633 11,1.50643854 L11,9.49356146 C11,10.3255445 10.3284594,11 9.49356146,11 L1.50643854,11 C0.674455507,11 0,10.3284594 0,9.49356146 L0,1.50643854 Z M3,3 L4,3 L4,4 L3,4 L3,3 Z M7,7 L8,7 L8,8 L7,8 L7,7 Z" id="propertiespath-1"></path><mask id="propertiesmask-2" maskContentUnits="userSpaceOnUse" maskUnits="objectBoundingBox" x="-1" y="-1" width="13" height="13"><rect x="-1" y="-1" width="13" height="13" fill="white"></rect><use xlink:href="#propertiespath-1" fill="black"></use></mask> </defs><g id="properties" stroke="none" fill="none"><use fill="#FFFFFF" fill-rule="evenodd" xlink:href="#propertiespath-1"></use></g></svg>'
    });
    this.right = new Layer({
      parent: this,
      backgroundColor: null,
      name: "options"
    });
    this.optionsIcon = new Layer({
      parent: this.right,
      width: 11,
      height: 11,
      backgroundColor: null,
      html: '<svg><defs><rect id="optionspath-2" x="0" y="0" width="11" height="11" rx="1.5"></rect><mask id="optionsmask-2" maskContentUnits="userSpaceOnUse" maskUnits="objectBoundingBox" x="-1" y="-1" width="13" height="13"><rect x="-1" y="-1" width="13" height="13" fill="white"></rect><use xlink:href="#optionspath-1" fill="black"></use></mask></defs><g id="icon-curve-edit" stroke="none" stroke-width="1" fill="none" fill-rule="evenodd"><g id="Rectangle-272"><use fill="#FFF" fill-rule="evenodd" xlink:href="#optionspath-2"></use><use stroke="#141414" mask="url(#optionsmask-2)" stroke-width="2" xlink:href="#optionspath-1"></use></g><path d="M2,8.5 C2,8.5 8.5,8.5 8.5,2" id="Path-64" stroke="#141414"></path></g></svg>'
    });
    ref = [this.left, this.right];
    for (i = 0, len = ref.length; i < len; i++) {
      layer = ref[i];
      if (layer.name !== options.currentTabName) {
        layer.opacity = 0.4;
      }
    }
    this.layout();
    this.left.onClick((function(_this) {
      return function() {
        return _this.emit("change:value", _this.left.name);
      };
    })(this));
    this.right.onClick((function(_this) {
      return function() {
        return _this.emit("change:value", _this.right.name);
      };
    })(this));
  }

  Tabs.prototype.layout = function() {
    var offset, width;
    width = this.width / 2;
    this.left.width = this.right.width = width;
    this.right.x = width;
    this.left.height = this.right.height = this.height;
    offset = 17;
    this.propertiesIcon.centerX(offset - 1);
    this.optionsIcon.centerX(-offset);
    this.propertiesIcon.centerY();
    this.optionsIcon.centerY();
    this.propertiesIcon.pixelAlign();
    return this.optionsIcon.pixelAlign();
  };

  return Tabs;

})(PanelRow);

exports.SwitchPanel = (function(superClass) {
  extend(SwitchPanel, superClass);

  function SwitchPanel(options) {
    if (options == null) {
      options = {};
    }
    this.render = bind(this.render, this);
    this.tabs = new Tabs({
      currentTabName: options.currentTabName
    });
    SwitchPanel.__super__.constructor.call(this, options);
    this.add(this.tabs);
  }

  SwitchPanel.prototype.render = function() {
    var i, len, offsetY, ref, row;
    offsetY = 0;
    ref = this.rows;
    for (i = 0, len = ref.length; i < len; i++) {
      row = ref[i];
      if (!row.visible) {
        continue;
      }
      row.width = this.width;
      row.y = offsetY;
      if (typeof row.layout === "function") {
        row.layout();
      }
      offsetY += row.calculatedHeight;
    }
    this.calculatedHeight = offsetY;
    return this.height = this.calculatedHeight;
  };

  return SwitchPanel;

})(Panel);



},{}]},{},[5])