(function e(t,n,r){function s(o,u){if(!n[o]){if(!t[o]){var a=typeof require=="function"&&require;if(!u&&a)return a(o,!0);if(i)return i(o,!0);throw new Error("Cannot find module '"+o+"'")}var f=n[o]={exports:{}};t[o][0].call(f.exports,function(e){var n=t[o][1][e];return s(n?n:e)},f,f.exports,e,t,n,r)}return n[o].exports}var i=typeof require=="function"&&require;for(var o=0;o<r.length;o++)s(r[o]);return s})({1:[function(require,module,exports){
'use strict';

/**
 * Representation of a single EventEmitter function.
 *
 * @param {Function} fn Event handler to be called.
 * @param {Mixed} context Context for function execution.
 * @param {Boolean} once Only emit once
 * @api private
 */
function EE(fn, context, once) {
  this.fn = fn;
  this.context = context;
  this.once = once || false;
}

/**
 * Minimal EventEmitter interface that is molded against the Node.js
 * EventEmitter interface.
 *
 * @constructor
 * @api public
 */
function EventEmitter() { /* Nothing to set */ }

/**
 * Holds the assigned EventEmitters by name.
 *
 * @type {Object}
 * @private
 */
EventEmitter.prototype._events = undefined;

/**
 * Return a list of assigned event listeners.
 *
 * @param {String} event The events that should be listed.
 * @returns {Array}
 * @api public
 */
EventEmitter.prototype.listeners = function listeners(event) {
  if (!this._events || !this._events[event]) return [];
  if (this._events[event].fn) return [this._events[event].fn];

  for (var i = 0, l = this._events[event].length, ee = new Array(l); i < l; i++) {
    ee[i] = this._events[event][i].fn;
  }

  return ee;
};

/**
 * Emit an event to all registered event listeners.
 *
 * @param {String} event The name of the event.
 * @returns {Boolean} Indication if we've emitted an event.
 * @api public
 */
EventEmitter.prototype.emit = function emit(event, a1, a2, a3, a4, a5) {
  if (!this._events || !this._events[event]) return false;

  var listeners = this._events[event]
    , len = arguments.length
    , args
    , i;

  if ('function' === typeof listeners.fn) {
    if (listeners.once) this.removeListener(event, listeners.fn, true);

    switch (len) {
      case 1: return listeners.fn.call(listeners.context), true;
      case 2: return listeners.fn.call(listeners.context, a1), true;
      case 3: return listeners.fn.call(listeners.context, a1, a2), true;
      case 4: return listeners.fn.call(listeners.context, a1, a2, a3), true;
      case 5: return listeners.fn.call(listeners.context, a1, a2, a3, a4), true;
      case 6: return listeners.fn.call(listeners.context, a1, a2, a3, a4, a5), true;
    }

    for (i = 1, args = new Array(len -1); i < len; i++) {
      args[i - 1] = arguments[i];
    }

    listeners.fn.apply(listeners.context, args);
  } else {
    var length = listeners.length
      , j;

    for (i = 0; i < length; i++) {
      if (listeners[i].once) this.removeListener(event, listeners[i].fn, true);

      switch (len) {
        case 1: listeners[i].fn.call(listeners[i].context); break;
        case 2: listeners[i].fn.call(listeners[i].context, a1); break;
        case 3: listeners[i].fn.call(listeners[i].context, a1, a2); break;
        default:
          if (!args) for (j = 1, args = new Array(len -1); j < len; j++) {
            args[j - 1] = arguments[j];
          }

          listeners[i].fn.apply(listeners[i].context, args);
      }
    }
  }

  return true;
};

/**
 * Register a new EventListener for the given event.
 *
 * @param {String} event Name of the event.
 * @param {Functon} fn Callback function.
 * @param {Mixed} context The context of the function.
 * @api public
 */
EventEmitter.prototype.on = function on(event, fn, context) {
  var listener = new EE(fn, context || this);

  if (!this._events) this._events = {};
  if (!this._events[event]) this._events[event] = listener;
  else {
    if (!this._events[event].fn) this._events[event].push(listener);
    else this._events[event] = [
      this._events[event], listener
    ];
  }

  return this;
};

/**
 * Add an EventListener that's only called once.
 *
 * @param {String} event Name of the event.
 * @param {Function} fn Callback function.
 * @param {Mixed} context The context of the function.
 * @api public
 */
EventEmitter.prototype.once = function once(event, fn, context) {
  var listener = new EE(fn, context || this, true);

  if (!this._events) this._events = {};
  if (!this._events[event]) this._events[event] = listener;
  else {
    if (!this._events[event].fn) this._events[event].push(listener);
    else this._events[event] = [
      this._events[event], listener
    ];
  }

  return this;
};

/**
 * Remove event listeners.
 *
 * @param {String} event The event we want to remove.
 * @param {Function} fn The listener that we need to find.
 * @param {Boolean} once Only remove once listeners.
 * @api public
 */
EventEmitter.prototype.removeListener = function removeListener(event, fn, once) {
  if (!this._events || !this._events[event]) return this;

  var listeners = this._events[event]
    , events = [];

  if (fn) {
    if (listeners.fn && (listeners.fn !== fn || (once && !listeners.once))) {
      events.push(listeners);
    }
    if (!listeners.fn) for (var i = 0, length = listeners.length; i < length; i++) {
      if (listeners[i].fn !== fn || (once && !listeners[i].once)) {
        events.push(listeners[i]);
      }
    }
  }

  //
  // Reset the array, or remove it completely if we have no more listeners.
  //
  if (events.length) {
    this._events[event] = events.length === 1 ? events[0] : events;
  } else {
    delete this._events[event];
  }

  return this;
};

/**
 * Remove all listeners or only the listeners for the specified event.
 *
 * @param {String} event The event want to remove all listeners for.
 * @api public
 */
EventEmitter.prototype.removeAllListeners = function removeAllListeners(event) {
  if (!this._events) return this;

  if (event) delete this._events[event];
  else this._events = {};

  return this;
};

//
// Alias methods names because people roll like that.
//
EventEmitter.prototype.off = EventEmitter.prototype.removeListener;
EventEmitter.prototype.addListener = EventEmitter.prototype.on;

//
// This function doesn't apply anymore.
//
EventEmitter.prototype.setMaxListeners = function setMaxListeners() {
  return this;
};

//
// Expose the module.
//
EventEmitter.EventEmitter = EventEmitter;
EventEmitter.EventEmitter2 = EventEmitter;
EventEmitter.EventEmitter3 = EventEmitter;

//
// Expose the module.
//
module.exports = EventEmitter;

},{}],2:[function(require,module,exports){
var Constants, bridge,
  bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

bridge = (require("./../shared/Bridge.coffee")).bridge;

Constants = require("./../shared/Constants.coffee").Constants;

exports.PropertiesPanel = (function(superClass) {
  extend(PropertiesPanel, superClass);

  function PropertiesPanel(options) {
    if (options == null) {
      options = {};
    }
    this.handleUndoValue = bind(this.handleUndoValue, this);
    this.handleExternalValueUpdate = bind(this.handleExternalValueUpdate, this);
    this.handlePropertyRequest = bind(this.handlePropertyRequest, this);
    this.handleLockPressed = bind(this.handleLockPressed, this);
    this.handlePropertyValueChange = bind(this.handlePropertyValueChange, this);
    this.handleLayerEdited = bind(this.handleLayerEdited, this);
    this.setData = bind(this.setData, this);
    PropertiesPanel.__super__.constructor.call(this, _.defaults(options, {}));
    bridge.responders.data = this.setData;
    bridge.responders.getToggleStates = (function(_this) {
      return function() {
        return _this.getToggleStates();
      };
    })(this);
    bridge.on("show", (function(_this) {
      return function() {
        return _this.visible = true;
      };
    })(this));
    bridge.on("hide", (function(_this) {
      return function() {
        return _this.visible = false;
      };
    })(this));
    bridge.on(Constants.messages.framerview.layerEdited, this.handleLayerEdited);
    bridge.on("externalValueUpdate", this.handleExternalValueUpdate);
    bridge.on("undoValue", this.handleUndoValue);
    this.directManipulationProperties = {
      x: {
        round: true,
        "default": "0"
      },
      y: {
        round: true,
        "default": "0"
      },
      width: {
        round: true,
        "default": Framer.Defaults.Layer.width.toString()
      },
      height: {
        round: true,
        "default": Framer.Defaults.Layer.height.toString()
      },
      rotation: {
        round: true,
        "default": "0"
      },
      rotationX: {
        round: true,
        "default": "0"
      },
      rotationY: {
        round: true,
        "default": "0"
      },
      rotationZ: {
        round: true,
        "default": "0"
      },
      scale: {
        round: false,
        "default": "1"
      },
      scaleX: {
        round: false,
        "default": "1"
      },
      scaleY: {
        round: false,
        "default": "1"
      },
      originX: {
        round: false,
        "default": "0.5"
      },
      originY: {
        round: false,
        "default": "0.5"
      },
      originZ: {
        round: false,
        "default": "0"
      },
      borderRadius: {
        round: true,
        "default": "0"
      }
    };
    this.omitDefaults = true;
    this.visible = false;
  }

  PropertiesPanel.prototype.destroy = function() {
    return this.reset();
  };

  PropertiesPanel.prototype.setData = function(data) {
    var key, ref, ref1, settings, value;
    this.reset();
    this.configure(data);
    this.initialValues = data != null ? data.layerProperties : void 0;
    if (this.initialValues == null) {
      this.initialValues = {};
    }
    ref = this.directManipulationProperties;
    for (key in ref) {
      value = ref[key];
      if (this.initialValues[key] == null) {
        this.initialValues[key] = value["default"];
      }
      value.initial = this.initialValues[key];
      value.changed = false;
    }
    settings = {};
    if ((ref1 = data.frozenMembers) != null) {
      ref1.forEach(function(frozenMember) {
        return settings[frozenMember] = {
          disabled: true
        };
      });
    }
    this.setMembers = data.setMembers;
    this.read(this.setMembers, this.initialValues, settings);
    this.addPropertyListeners();
    return window.scrollTo(0, 0);
  };

  PropertiesPanel.prototype.getData = function() {
    return this.write();
  };

  PropertiesPanel.prototype.addPropertyListeners = function() {
    var i, len, property, ref, results;
    ref = this.properties;
    results = [];
    for (i = 0, len = ref.length; i < len; i++) {
      property = ref[i];
      property.on("change:value", this.handlePropertyValueChange);
      results.push(property.on("clickedOnLock", this.handleLockPressed));
    }
    return results;
  };

  PropertiesPanel.prototype.removePropertyListeners = function() {
    var i, len, property, ref, results;
    ref = this.properties;
    results = [];
    for (i = 0, len = ref.length; i < len; i++) {
      property = ref[i];
      property.off("change:value", this.handlePropertyValueChange);
      results.push(property.reset());
    }
    return results;
  };

  PropertiesPanel.prototype.reset = function() {
    return this.removePropertyListeners();
  };

  PropertiesPanel.prototype.propertyByDataPath = function(dataPath) {
    var i, len, property, ref;
    ref = this.properties;
    for (i = 0, len = ref.length; i < len; i++) {
      property = ref[i];
      if (property.dataPath === dataPath) {
        return property;
      }
    }
    return null;
  };

  PropertiesPanel.prototype.handleLayerEdited = function(data) {
    var changedProperties, currentValue, dataPath, newValue, property, ref, settings, value;
    this.inBatchMode = true;
    changedProperties = [];
    ref = this.directManipulationProperties;
    for (dataPath in ref) {
      settings = ref[dataPath];
      newValue = data.properties[dataPath];
      property = this.propertyByDataPath(dataPath);
      if (newValue == null) {
        continue;
      }
      if (!((property != null ? property.changed : void 0) || (this.setMembers[dataPath] != null))) {
        if ((settings.initial + "") === (newValue + "")) {
          continue;
        }
      }
      if (settings.round) {
        value = Math.round(newValue);
      } else {
        value = newValue;
      }
      if (value != null) {
        value = value + "";
      }
      if (this.omitDefaults) {
        if ("" + value === settings["default"]) {
          value = null;
        }
      }
      if (value !== void 0 && (property != null)) {
        if (property != null) {
          if (!this.omitDefaults && !property.changed && value === property["default"] + "") {
            value = null;
          }
          currentValue = property.valueToData();
          if ((value === null && currentValue !== null) || (value !== null && value.toString() !== currentValue)) {
            property.valueFromData(value);
            property.changed = true;
            changedProperties.push({
              name: dataPath,
              value: value,
              type: property.type
            });
          }
        }
      }
    }
    if (changedProperties.length > 0) {
      bridge.send(Constants.messages.propertiespanel.propertiesChanged, {
        properties: changedProperties
      });
    }
    return this.inBatchMode = false;
  };

  PropertiesPanel.prototype.handlePropertyValueChange = function(newValue, oldValue, prop) {
    var update, value;
    if (this.inBatchMode) {
      return;
    }
    value = prop.valueToData();
    if (value == null) {
      value = this.initialValues[prop.dataPath];
    }
    update = {
      name: prop.dataPath,
      value: value,
      type: prop.type
    };
    return bridge.send(Constants.messages.propertiespanel.propertyChanged, update);
  };

  PropertiesPanel.prototype.handleLockPressed = function(prop) {
    var update;
    update = {
      name: prop.dataPath
    };
    return bridge.send(Constants.messages.propertiespanel.propertyLockPressed, update);
  };

  PropertiesPanel.prototype.handlePropertyRequest = function(request) {
    switch (request != null ? request.type : void 0) {
      case "color":
        return bridge.send("colorPickerRequested", request);
      case "image":
        return bridge.send("imagePickerRequested", request);
      case "drag:start":
        document.body.classList.add("dragging");
        return bridge.send("drag:start", {});
      case "drag:end":
        document.body.classList.remove("dragging");
        return bridge.send("drag:end", {});
      case "indicate":
        return bridge.send("indicate", request);
    }
  };

  PropertiesPanel.prototype.handleExternalValueUpdate = function(update) {
    var property;
    property = this.propertyByDataPath(update != null ? update.name : void 0);
    if (property != null) {
      return property.value = update.value;
    }
  };

  PropertiesPanel.prototype.handleUndoValue = function(update) {
    var inBatchMode;
    inBatchMode = this.inBatchMode;
    this.inBatchMode = true;
    this.handleExternalValueUpdate(update);
    return this.inBatchMode = inBatchMode;
  };

  return PropertiesPanel;

})(window.FramerStudioComponents.PropertiesPanel);



},{"./../shared/Bridge.coffee":4,"./../shared/Constants.coffee":5}],3:[function(require,module,exports){
var Constants, PropertiesPanel, Scroller, bridge, scroller;

bridge = (require("./../shared/Bridge")).bridge;

Constants = require("./../shared/Constants").Constants;

Scroller = require("./../shared/Scroller").Scroller;

PropertiesPanel = require("./PropertiesPanel").PropertiesPanel;

document.addEventListener("contextmenu", function(event) {
  return event.preventDefault();
}, false);

scroller = new Scroller({
  backgroundColor: Constants.colors.background
});

new PropertiesPanel({
  superLayer: scroller,
  backgroundColor: Constants.colors.background
});

Framer.Extras.TouchEmulator.disable();

Framer.Extras.ErrorDisplay.disable();



},{"./../shared/Bridge":4,"./../shared/Constants":5,"./../shared/Scroller":6,"./PropertiesPanel":2}],4:[function(require,module,exports){
var Bridge, EventEmitter,
  bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

EventEmitter = require("eventemitter3");

Bridge = (function(superClass) {
  extend(Bridge, superClass);

  function Bridge() {
    this.respond = bind(this.respond, this);
    this.receive = bind(this.receive, this);
    if (typeof window !== "undefined" && window !== null) {
      window._receive = this.receive;
    }
    if (typeof window !== "undefined" && window !== null) {
      window._respond = this.respond;
    }
    this.count = 0;
    this.responders = {};
  }

  Bridge.prototype.receive = function(command, info) {
    if (this.debug) {
      console.log((this.count++) + " bridge.receive", command, info);
    }
    return this.emit(command, info);
  };

  Bridge.prototype.respond = function(request, info) {
    var responder;
    responder = this.responders[request];
    if (responder != null) {
      return responder(info);
    } else {

    }
  };

  Bridge.prototype.send = function(command, info) {
    if (this.debug) {
      console.log((this.count++) + " bridge.send", command, info);
    }
    return typeof window !== "undefined" && window !== null ? typeof window._bridge === "function" ? window._bridge(command, info) : void 0 : void 0;
  };

  return Bridge;

})(EventEmitter);

exports.bridge = new Bridge();



},{"eventemitter3":1}],5:[function(require,module,exports){
exports.Constants = {
  fonts: {
    "default": {
      font: "11px -apple-system, Helvetica Neue, Helvetica",
      weight: "500"
    }
  },
  colors: {
    background: "#141414",
    text: "#888888",
    textHighlight: "#FFFFFF",
    textInvisible: "rgba(98,98,98,.4)",
    indent: "#303030",
    tableSelectionBackground: "#363636"
  },
  sizes: {
    base: 10,
    rowHeight: 28,
    indent: 12,
    indentWidth: 1,
    indentHeight: 28
  },
  messages: {
    layerpanel: {
      reset: "layerPanel:reset",
      itemRollOver: "layerPanel:itemRollover",
      itemRollOut: "layerPanel:itemRollout",
      itemClick: "layerPanel:itemClick"
    },
    propertiespanel: {
      propertiesChanged: "propertiesPanel:propertiesChanged",
      propertyChanged: "propertiesPanel:propertyChanged",
      propertyLockPressed: "propertiespanel:propertyLockPressed"
    },
    framerview: {
      layers: "framerView:layers",
      layerEdited: "framerView:layerEdited",
      layerHighlighted: "framerView:layerHighlighted"
    },
    studio: {
      state: "studio:state",
      layerPanelEnter: "studio:layerPanelEnter",
      layerPanelLeave: "studio:layerPanelLeave"
    }
  }
};



},{}],6:[function(require,module,exports){
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

exports.Scroller = (function(superClass) {
  extend(Scroller, superClass);

  function Scroller(options) {
    if (options == null) {
      options = {};
    }
    Scroller.__super__.constructor.call(this, _.defaults(options, {
      name: "Scroller",
      width: window.innerWidth,
      height: window.innerHeight,
      backgroundColor: null,
      clip: true
    }));
    this.scroll = true;
    this.scrollHorizontal = false;
    window.addEventListener("resize", (function(_this) {
      return function() {
        var child, i, len, ref, results;
        _this.height = window.innerHeight;
        _this.width = window.innerWidth;
        ref = _this.children;
        results = [];
        for (i = 0, len = ref.length; i < len; i++) {
          child = ref[i];
          results.push(typeof child.handleScrollerResize === "function" ? child.handleScrollerResize(_this.width, _this.height) : void 0);
        }
        return results;
      };
    })(this));
  }

  return Scroller;

})(Layer);



},{}]},{},[3])